package rocks.zipcode.io.quiz4.fundamentals;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeEvaluator {
    public static String[] getAllPalindromes(String string) {
        String[] arr = new String[string.length()];
        Set<String> set = new HashSet<>();
        for (int i = 0; i < string.length(); i++)
        {
            // find all odd length palindrome with str[i] as mid point
            expand(string, i, i, set);
            // find all even length palindrome with str[i] and str[i+1]
            // as its mid points
            expand(string, i, i + 1, set);
        }
        for (int i = 0; i <set.size() ; i++) {
            arr = set.toArray(new String[i]);
        }
        return arr;
    }

    public static Boolean isPalindrome(String string) {
        String string2 = reverseString(string);

        return Objects.equals(string, string2);
    }

    public static String reverseString(String string) {
        StringBuilder sb = new StringBuilder(string);
        sb.reverse();
        return sb.toString();
    }

    public static void expand(String str, int low, int high, Set<String> set)
    {
        // run till str[low.high] is a palindrome
        while (low >= 0 && high < str.length()
                && str.charAt(low) == str.charAt(high))
        {
            // push all palindromes into the set
            set.add(str.substring(low, high + 1));

            // expand in both directions
            low--;
            high++;
        }
    }
}
